%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}

%bcond_without check

%global crate scx_rusty

Name:           rust-scx_rusty
Version:        0.5.4
Release:    1%{?dist}
Summary:        A multi-domain, BPF / user space hybrid scheduler

License:        GPL-2.0-only
URL:            https://crates.io/crates/scx_rusty
Source0:         %{crates_source}

BuildRequires:  cargo-rpm-macros >= 24
ExcludeArch:    %{ix86}

%global _description %{expand:
A multi-domain, BPF / user space hybrid scheduler used within sched_ext, 
which is a Linux kernel feature which enables implementing kernel thread 
schedulers in BPF and dynamically loading them. 
https://github.com/sched-ext/scx/tree/main}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
License:        GPL-2.0-only AND (MIT OR Apache-2.0) AND Unicode-DFS-2016 AND Apache-2.0 AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND BSD-2-Clause AND BSD-3-Clause AND (BSD-3-Clause OR MIT OR Apache-2.0) AND ISC AND (LGPL-2.1-only OR BSD-2-Clause) AND MIT AND (Unlicense OR MIT) AND Zlib

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%{_bindir}/scx_rusty

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
%cargo_install

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Tue Jun 18 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.4-1
- initial build
